<?php
namespace Teknisa\CADFIN\Controllers;

use Teknisa\CADFIN\Services\PrevisoesService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;

class PrevisoesController {

    protected $previsoesService;

    public function __construct(PrevisoesService $previsoesService) {
        $this->previsoesService = $previsoesService;
    }

    public function cadAutoPrevisoes(Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            
            $this->previsoesService->cadAutoPrevisoes($row);

        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function deleteGrupoDataSaida(Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            
            $this->previsoesService->deleteGrupoDataSaida($row);

        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function deleteGrupoRelacSaida(Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            
            $this->previsoesService->deleteGrupoRelacSaida($row);

        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function deleteGrupoDataEntrada(Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            
            $this->previsoesService->deleteGrupoDataEntrada($row);

        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function deleteGrupoRelacEntrada(Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            
            $this->previsoesService->deleteGrupoRelacEntrada($row);

        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}