/* Sistemas Integrados TECNISA

Nome: 5031_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   21/06/2012 - Marcelo Alexsandro

Tabela REGRAFISCAL: Regra Fiscal.
Descrio: A trigger insere registros na tabela LOGREGRAFISCAL a partir de alteraes na tabela REGRAFISCAL
*/

CREATE OR REPLACE TRIGGER LOG_FIS_REGRAFISCAL
AFTER DELETE OR INSERT OR UPDATE
ON REGRAFISCAL FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(3000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      V_DESC   := 'Nome = '                 || '' || :NEW.NMREGRAFISC                         || ' ' ||
                  'Grupo Imposto  = '       || '' || :NEW.CDGRUPIMPOSTO                       || ' ' ||
                  'Obs.: = '                || '' || :NEW.DSMENSREGRAFISC                     || ' ' ||
                  'Status = '               || '' || :NEW.IDATIVREGRAFISC                     || ' ' ||
                  'Util Grupo Fiscal = '    || '' || :NEW.IDUTGRUPOFISCAL                     || ' ' ||
                  'Validade = '             || '' || TO_CHAR(:NEW.DTVALREGRAFISC, 'DD/MM/YYYY');
      V_ITPESQ       := :NEW.CDREGRAFISC;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Nome = '                 || '' || :NEW.NMREGRAFISC                         || ' ' ||
                     'Grupo Imposto = '        || '' || :NEW.CDGRUPIMPOSTO                       || ' ' ||
                     'Obs.: = '                || '' || :NEW.DSMENSREGRAFISC                     || ' ' ||
                     'Status = '               || '' || :NEW.IDATIVREGRAFISC                     || ' ' ||
                     'Util Grupo Fiscal = '    || '' || :NEW.IDUTGRUPOFISCAL                     || ' ' ||
                     'Validade = '             || '' || TO_CHAR(:NEW.DTVALREGRAFISC, 'DD/MM/YYYY');
         V_ITPESQ       := :NEW.CDREGRAFISC;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Nome = '                 || '' || :OLD.NMREGRAFISC                         || ' ' ||
                        'Grupo Imposto = '        || '' || :OLD.CDGRUPIMPOSTO                       || ' ' ||
                        'Obs.: = '                || '' || :OLD.DSMENSREGRAFISC                     || ' ' ||
                        'Status = '               || '' || :OLD.IDATIVREGRAFISC                     || ' ' ||
                        'Util Grupo Fiscal = '    || '' || :OLD.IDUTGRUPOFISCAL                     || ' ' ||
                        'Validade = '             || '' || TO_CHAR(:OLD.DTVALREGRAFISC, 'DD/MM/YYYY');
            V_ITPESQ       := :OLD.CDREGRAFISC;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 3000);
   INSERT INTO LOGREGRAFISCAL
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER)
    VALUES
      ('REGRAFISCAL',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_REGRAFISCAL','5.33.xxx'); END;
/
